/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-summary.html
 */

/// <reference path="../polymer/types/polymer-element.d.ts" />
/// <reference path="../polymer/types/lib/elements/dom-if.d.ts" />
/// <reference path="../raml-aware/raml-aware.d.ts" />
/// <reference path="../iron-flex-layout/iron-flex-layout.d.ts" />
/// <reference path="../markdown-styles/markdown-styles.d.ts" />
/// <reference path="../marked-element/marked-element.d.ts" />
/// <reference path="../iron-meta/iron-meta.d.ts" />
/// <reference path="../amf-helper-mixin/amf-helper-mixin.d.ts" />

declare namespace ApiElements {

  /**
   * `api-summary`
   *
   * A summary view for an API base on AMF data model
   *
   * ## Styling
   *
   * `<api-summary>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-summary` | Mixin applied to this elment | `{}`
   * `--api-summary-url-font-size` | Font size of endpoin URL | `16px`
   * `--api-summary-url-background-color` | Background color of the URL section | `#424242`
   * `--api-summary-url-font-color` | Font color of the URL area | `#fff`
   * `--api-summary-url-title` | Mixin applied to URL title label | `--arc-font-subhead`
   */
  class ApiSummary extends
    ApiElements.AmfHelperMixin(
    Polymer.Element) {

    /**
     * `raml-aware` scope property to use.
     */
    aware: string|null|undefined;

    /**
     * Computed value of AMF model of a type of `http://schema.org/WebAPI`
     */
    readonly webApi: object|null;

    /**
     * A property to set to override AMF's model base URI information.
     * When this property is set, the `endpointUri` property is recalculated.
     */
    baseUri: string|null|undefined;

    /**
     * API base URI to display in main URL field.
     * This value is computed when `amfModel` or `baseUri` change.
     */
    readonly apiBaseUri: string|null|undefined;

    /**
     * Computed title of the API
     */
    readonly apiTitle: string|null|undefined;

    /**
     * Computed value of method description from `method` property.
     */
    readonly description: string|null|undefined;

    /**
     * Computed value of the `http://raml.org/vocabularies/http#server`
     * from `amfModel`
     */
    readonly server: object|null|undefined;

    /**
     * Computed API version label
     */
    readonly version: string|null|undefined;
    readonly hasVersion: boolean|null|undefined;
    readonly protocols: string|null|undefined;
    readonly hasProtocols: boolean|null|undefined;
    readonly provider: object|null|undefined;
    readonly hasProvider: boolean|null|undefined;
    readonly providerName: string|null|undefined;
    readonly providerEmail: string|null|undefined;
    readonly providerUrl: string|null|undefined;
    readonly termsOfService: string|null|undefined;
    readonly license: object|null|undefined;
    readonly hasLicense: boolean|null|undefined;
    readonly licenseName: string|null|undefined;
    readonly licenseUrl: string|null|undefined;

    /**
     * Computes value of `apiTitle` property.
     *
     * @param shape Shape of AMF model.
     * @returns Description if defined.
     */
    _computeApiTitle(shape: object|null): String|null|undefined;
    _computeVersion(webApi: any): any;

    /**
     * Computes API's URI based on `amfModel` and `baseUri` property.
     *
     * @param server Server model of AMF API.
     * @param baseUri Current value of `baseUri` property
     * @param protocols List of supported protocols
     * @returns Endpoint's URI
     */
    _computeBaseUri(server: object|null, baseUri: String|null, protocols: Array<String|null>|null): String|null;

    /**
     * Displays array values.
     */
    _displayArray(arr: any): any;

    /**
     * Computes information about provider of the API.
     *
     * @param webApi WebApi shape
     */
    _computeProvider(webApi: object|null): object|null|undefined;
    _computeName(provider: any): any;
    _computeEmail(provider: any): any;
    _computeUrl(provider: any): any;
    _computeToS(webApi: any): any;
    _computeLicense(webApi: any): any;
  }
}

interface HTMLElementTagNameMap {
  "api-summary": ApiElements.ApiSummary;
}
